CREATE TABLE "RAW_FILE"
(
InsertTime Date DEFAULT to_date('2011/01/01 12:00:00am', 'yyyy/mm/dd hh:mi:ssam') NOT NULL, 
FileName VARCHAR2(400 BYTE) DEFAULT 'unknown' NOT NULL,
FILEEXITFLAG NUMBER(1,0) DEFAULT 0 NOT NULL ,   
Filesize NUMBER(38,0) DEFAULT 0 NOT NULL,
FILETYPE VARCHAR2(100 BYTE) DEFAULT 'unknown' NOT NULL,
PROTOCOL VARCHAR2(100 BYTE) DEFAULT 'unknown' NOT NULL,
IsParent NUMBER(1,0) DEFAULT 0 NOT NULL,
IsRemote NUMBER(1,0) DEFAULT 0 NOT NULL,
LumiRange VARCHAR2(4000 BYTE) DEFAULT 'unknown' NOT NULL,
FileExecExitCode NUMBER(38,0) DEFAULT 0 NOT NULL, 
FileStartedRunningTimeStamp Date DEFAULT to_date('2011/01/01 12:00:00am', 'yyyy/mm/dd hh:mi:ssam') NOT NULL, 
FileFinishedTimeStamp Date DEFAULT to_date('2011/01/01 12:00:00am', 'yyyy/mm/dd hh:mi:ssam') NOT NULL,
FileRunningTime NUMBER(16,2) DEFAULT 0 NOT NULL, 
BlockId  NUMBER(38,0) DEFAULT 0 NOT NULL,
BlockName VARCHAR2(400 BYTE) DEFAULT 'unknown' NOT NULL,
InputCollection VARCHAR2(2500) DEFAULT 'unknown' NOT NULL,      
Application VARCHAR2(256) DEFAULT 'unknown' NOT NULL,           
TaskType VARCHAR2(256) DEFAULT 'unknown' NOT NULL,              
SubmissionTool VARCHAR2(256) DEFAULT 'unknown' NOT NULL,
InputSE VARCHAR2(100 BYTE) DEFAULT 'unknown',
TargetCE VARCHAR2(256) DEFAULT 'unknown' NOT NULL,
SiteName VARCHAR2(128) DEFAULT 'unknown' NOT NULL,
SchedulerName VARCHAR2(512) DEFAULT 'unknown' NOT NULL, 
JobId NUMBER(38,0) DEFAULT 0 NOT NULL, 
JobMonitorId VARCHAR2(256) DEFAULT 'unknown' NOT NULL, 
TaskMonitorId VARCHAR2(256) DEFAULT 'unknown' NOT NULL, 
TaskJobId NUMBER(38,0) DEFAULT 0 NOT NULL, 
TaskId NUMBER(38,0) DEFAULT 0 NOT NULL,
JobExecExitCode NUMBER(38,0) DEFAULT 0 NOT NULL, 
JobExecExitTimeStamp Date DEFAULT to_date('2011/01/01 12:00:00AM', 'yyyy/mm/dd hh:mi:ssam') NOT NULL,
StartedRunningTimeStamp Date DEFAULT to_date('2011/01/01 12:00:00AM', 'yyyy/mm/dd hh:mi:ssam') NOT NULL, 
FinishedTimeStamp Date DEFAULT to_date('2011/01/01 12:00:00AM', 'yyyy/mm/dd hh:mi:ssam') NOT NULL,
WallClockCpuTime NUMBER(16,2) DEFAULT 0 NOT NULL, 
CpuTime NUMBER(16,2) DEFAULT 0 NOT NULL,
UserId NUMBER(38,0) DEFAULT 0 NOT NULL, 
UserName VARCHAR2(128) DEFAULT 'unknown' NOT NULL,
CONSTRAINT "PK_RAW_FILE" PRIMARY KEY (FinishedTimeStamp,Filename, JobId),   
CONSTRAINT "RAW_FILE_UC" UNIQUE (Filename, JobId),
CONSTRAINT "CHK_ISPARENT" CHECK (IsParent IN (-1,1,0)  ) ENABLE,
CONSTRAINT "CHK_ISREMOTE" CHECK (IsRemote IN (-1,1,0)  ) ENABLE)
COMPRESS
PARTITION BY RANGE(FINISHEDTIMESTAMP)
(PARTITION files_apr2011 VALUES LESS THAN(TO_DATE('01/05/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_may2011 VALUES LESS THAN(TO_DATE('01/06/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_jun2011 VALUES LESS THAN(TO_DATE('01/07/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_jul2011 VALUES LESS THAN(TO_DATE('01/08/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_aug2011 VALUES LESS THAN(TO_DATE('01/09/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_sep2011 VALUES LESS THAN(TO_DATE('01/10/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_oct2011 VALUES LESS THAN(TO_DATE('01/11/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_nov2011 VALUES LESS THAN(TO_DATE('01/12/2011','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011,
PARTITION files_dec2011 VALUES LESS THAN(TO_DATE('01/01/2012','DD/MM/YYYY')) tablespace CMS_POPULARITY_SYSTEM_DATA2011
);


ALTER TABLE RAW_FILE SET INTERVAL(NUMTODSINTERVAL(1, 'day'));

--ALTER TABLE RAW_FILE SET STORE IN (CMS_POPULARITY_SYSTEM_DATA2012);

ALTER TABLE RAW_FILE SET STORE IN (CMS_POPULARITY_SYSTEM_DATA2013);

--drop index IN_RAW_FILE_A;

create index IN_RAW_FILE_A on RAW_FILE ( trunc(FinishedTimeStamp) );

create index IN_RAW_FILE_B on RAW_FILE ( FinishedTimeStamp );
